function qrs=challenge_core(iqrs,rsig,Fs)
%% RESAMPE
rsig=rsig(:,1)';
sfakt=1; 
if(Fs~=250)
       p=250;
       q=Fs;
    t=gcd(p,q);  
    p=p/t;     q=q/t; 
    t=1:q:(p*size(rsig,2)); 
    rrsig=zeros(size(rsig,1), size(t,2)); 
     T=q; 
    beta=0.5;
    t=-4*T:4*T;
h=(sin(pi*t/T)./(pi*t/T)).*cos(pi*beta.*t/T)./(1-4*beta^2*t.^2/T^2); 
h(1,isinf(h))=0; 

for n=1:size(rsig,1)
    % up-sample
    x=ones(p,1)*rsig(n,:); 
    x=x(:)';
    % lowpaass-filter
       x=conv(x,h/T,'same'); 
    % downsample
    rrsig(n,:)=x(1,1:q:end); 
    
end
sfakt=p/q; 
  Fs=250;    
else
    rrsig=rsig;
end
%% PREPROCES 
 sig =prepro_signals(rrsig,Fs);
 %% Morphology
 ebbi=mean(diff(iqrs)); 
 initial_beats=iqrs; 
 [morpho]=calc_morpho(sig,initial_beats,ebbi);     
mindist=round(ebbi/2);
 threshs=[1:-0.05:0.3];
qrs=[];mb=zeros(1,size(morpho,2))==1;
for th=threshs
  bigger=double((morpho)>th);bigger(1,1)=0; bigger(1,end)=0; 
db=[0, diff(bigger)];
new_peaks=round((find(db>0)+find(db<0))/2); % contains detected beats
new_peaks=new_peaks(1,mb(1,new_peaks)==0);
qrs=[qrs, new_peaks];
 mb=[mb|conv(bigger,ones(1,2*mindist+1),'same')>0];
end
qrs=sort(qrs);

%% WRITE BACK
qrs=qrs/sfakt; 

end

function [sig] =prepro_signals(rsig,Fs)
% preprocess the ecg ( 1. Channel) 
N=size(rsig,2); 
numChan=size(rsig,1);
sig=zeros(numChan, N); 
 sig_h=conv2(rsig(1,:),ones(1,5)/(5),'same');
 sig_l=conv2(rsig(1,:),ones(1,round(Fs/6)*2+1)/(2*round(Fs/6)+1),'same'); 
 sig(1,:)=sig_h-sig_l; 
 % preprocess the others
 if(size(rsig,1)>1)
 sig_h=conv2(rsig(2:end,:),ones(1,5)/(5),'same');
 sig_l=conv2(rsig(2:end,:),ones(1,round(Fs/2)*2+1)/(2*round(Fs/2)+1),'same'); 
 sig(2:end,:)=sig_h-sig_l; 
 end
for k=1:size(sig,1) %loop through channels
     nd=round(N/20); 
    count=0;
    m=zeros(1,10); 
  for n=round(N/10):round(N/10):(N-N/10) 
      count=count+1;
      tsig=sig(k,n+[-nd:nd]);
      m(1,count)=max(abs(tsig));
 
  end
  m=m(1,m~=0); 
      thresh=2*median(m);
      bad=conv(double(abs(sig(k,:))>thresh),ones(1,round(Fs/10)),'same')>0;
   sig(k,bad|isnan(sig(k,:)))=0; 
   skalier=(0.01+std(sig(k,:)));
   sig(k,:)=sig(k,:)/skalier; 
 end


end

function [morpho ]=calc_morpho(sig,ibeats,ebbi)
    % calc mean morpho --------------------
                md=ebbi(1,1);
               beg=round(md*2/4); ende=round(md*3/4);
                win=-beg:ende;   amSig=size(sig,1);
                  imorpho=zeros(amSig, size(win,2), size(ibeats,2)); 
                for k=1:(size(ibeats,2))
                    temp=ibeats(k)+win; 
                    if(temp(1,1)<1||temp(1,end)>size(sig,2))
                        continue;
                    end
                    imorpho(:,:,k)=sig(1:amSig,temp); % shapes of each and every single potential beat
                end
L=round(15*md); % Intervals of length L  miliSekunden
Imids=(1+L):L:(size(sig,2)-L); % 
Imids=[Imids,size(sig,2)-L];
         
%% mean-morpho
immmorpho=mean(imorpho,3);

stdmshape=std(immmorpho,1,2);
good=stdmshape>0.5*max(stdmshape(1,:)); 
immmorpho=immmorpho(good,:);
imorpho=imorpho(good,:,:);
sig=sig(good,:);
amSig=size(immmorpho,1);
morpho=zeros(amSig,size(sig,2)); 

ww=[-round(md/3):round(md/3)]; % Intervall
morphos=zeros(amSig,size(ww,2), size(ibeats,2)); 
 maxanstieg=zeros(amSig,1); 
 index=zeros(amSig,1); 
 mmmorphol=zeros(amSig,size(ww,2)); 
 initial_versatz=zeros(amSig,1); 
for n=1:amSig
    [maxanstieg(n,1), index(n,1)]=max(abs(immmorpho(n,:)));
     if(index(n,1)>size(win,2)-ww(1,end))
         index(n,1)=size(win,2)-ww(1,end);
         
     elseif(index(n,1)+ww(1,1)<1)
        index(n,1)=-ww(1,1)+1; 
       
     end
             morphos(n,:,:)=imorpho(n,index(n,1)+ww,:);
             mmmorphol(n,:)=immmorpho(n,index(n,1)+ww); 
     
   initial_versatz(n,1)=index(n,1)-(beg+1);   
end


ttt=1;
td=zeros(1,size(ibeats,2)); 
while (ttt<=size(Imids,2))
T=Imids(1,ttt); 
ttt=ttt+1; 
    Interv=T+[-L:L];
    % pick out the shapes of those beats which ly within the current interval
   
    
time_diff=abs(T-ibeats);
close=time_diff(1,:)<L;
close_morpho=morphos(:,:,close); % those shapes ly within the current interval , they will be averaged !
mmorpho=zeros(amSig,size(close_morpho,2)); 
for n=1:amSig
    temp=mean(close_morpho(n,:,:),3) ; 
    mmorpho(n,:)=temp; 
    if(std(mmorpho(n,:))<std(mmmorphol(n,:)))
        %shapes=reshape(those_shapes(n,:,:),[size(those_shapes,3),size(those_shapes,2), 1]); 
         [mmorpho(n,:)]=rmmorpho(close_morpho(n,:,:));
         if(sum(mmorpho(n,:),2)==0)
             mmorpho(n,:)=mmmorphol(n,:); 
         end
    end
      
end

for n=1:amSig
 
  anstieg=abs(conv(mmorpho(n,:), [-ones(1,3),0,ones(1,3)],'same') );
  anstieg(1,1:3)=0; anstieg(1,end+(-2:0))=0; 
    [~,m]=max(anstieg );

    if(m(1,1)<=round(md(1,1)/7)||m(1,1)>(size(mmorpho,2)-round(md(1,1)/7)))
        m=-ww(1,1);
    end
    submo=mmorpho(n,m+[-round(md/7):round(md/7)]); 
        cov=(conv2(sig(n,Interv),submo(1,end:-1:1),'same')); % COVAR
        sig_var=conv2(sig(n,Interv).^2,ones(1,size(submo,2)),'same'); % signal-variance
        mshape_var=sum(mmorpho(n,:).^2,2); % shape- variance
    rerr=(sig_var-mshape_var)/mshape_var;
    b=(0.5+3*(rerr>0));    Enc=exp(-0.5*(rerr./b).^2); 
    new_simis=cov./(0.0001+sqrt(sig_var.*mshape_var)).*Enc;
    vdz=m+ww(1,1)+initial_versatz(n,1); 
    if(vdz>0) % links schieben
        new_simis=[new_simis(1,(1+vdz):end),zeros(1,vdz)];
    else % rechts schieben
         new_simis=[zeros(1,-vdz), new_simis(1,1:(end+vdz))];
    end
    morpho(n,Interv)=max(morpho(n,Interv),new_simis);% max() wird genutzt, weil "Interv" ueberlappen, somit werden Bereiche mit geringen Werten überschrieben % Similarities !!!
end % Ende Channel-Loop

%% +++++++++++++++++++++++++++++++++++++++++++++
end %   
morpho=-0.05+1.05./(1+exp(-4*(sum(morpho,1)-0.5)));

end

function [mmorpho]=rmmorpho(morpho)
N=size(morpho,3); 
numGood=0; counter=0;err=zeros(1,N); 
%figure; hold on; for k=1:N,  plot(shapes(1,:,k)-k*5);end
while(numGood<round(N/2)&&counter<N)
    counter=counter+1; 
    for kk=1:N
        err(1,kk)=sum(abs(morpho(1,:,kk)-morpho(1,:,counter)),2); 
        
    end
    good=err<0.5*sum(abs(morpho(1,:,counter)),2);
    numGood=sum(good,2); 
    
end
if(counter<N)
mmorpho=mean(morpho(1,:,good),3); 
else
    mmorpho=zeros(1,size(morpho,2));
end
   
end







